Snek_3d = require("snek_3d.snek_3d")
Dimetric_Map = require("dimetric")

local Bebo = require("bebo")
local Shadow = require("shadow")
local g = {
	map = nil,
	mobs = {},
}
function g.init ()
	UTIL.unset_love_hooks()
	if IS_MOBILE then
		TOUCH_CONTROLS.init()
	end
	LOVESIZE:set(800, 600)
	LG.setFont(LG.newFont(32))
	love.draw = g.draw
	love.update = g.update
	love.resize = function (w, h)
		if IS_MOBILE then
			TOUCH_CONTROLS.resize(w, h)
		end
		LOVESIZE:resize(w, h)
	end

	g.map = Dimetric_Map:create(LEVELS.test)
	local bebo = Bebo:create(3, 2, 0, g.map)
	local shadow = Shadow:create(3, 2, 0, g.map, bebo)

	g.mobs[#g.mobs + 1] = shadow
	g.map:add_object(
		shadow.pos,
		shadow.width,
		shadow.height,
		function () shadow:draw() end
	)

	g.mobs[#g.mobs + 1] = bebo
	g.map:add_object(
		bebo.pos,
		bebo.width,
		bebo.height,
		function () bebo:draw() end
	)

end

function g.exit ()
	MENU.init()
end

function g.update (dt)
	INPUT:update()
	for i = 1, #g.mobs do
		g.mobs[i]:update(dt)
	end
	if INPUT:pressed("back") then
		g.exit()
	end
end

function g.draw (screen)
	local draw_game_screen = (screen == "left") or not IS_3DS
	local w, h = LG.getWidth(), LG.getHeight()
	if draw_game_screen then
		LG.setColor(0, 0, 0)
		g.map:draw(0, 0, w, h)
		LG.setColor(0, 0, 0)
		LG.print(love.timer.getFPS(), 10, 10)
		LG.setColor(1, 1, 1)
		LG.print(love.timer.getFPS(), 10, 30)
	end
end

return g
