local Shadow = {}
Shadow.__index = Shadow
setmetatable(Shadow, Mob)

function Shadow:create (x, y, z, map, mob)
	local shadow = {}
	setmetatable(shadow, Shadow)
	shadow.map = map
	shadow.mob = mob
	shadow.pos = {
		x = x,
		y = y,
		z = z,
	}
	shadow.width = .75
	shadow.height = .75
	return shadow
end

function Shadow:update (dt)
	self.pos.x = self.mob.pos.x
	self.pos.y = self.mob.pos.y
	self.pos.z = self.map:get_elevation(self.pos.x, self.pos.y)
end

function Shadow:draw ()
	LG.push()
	LG.origin()
	local x, y = self.map:tile_pos_to_screen(
		self.mob.pos.x,
		self.mob.pos.y
	)
	y = y - self.pos.z * self.map:get_block_base_height()
	LG.setColor(0, 0, 0, .5)
	LG.ellipse(
		"fill",
		x,
		y,
		self.width / 4 * self.map.tilesize,
		self.height / 8 * self.map.tilesize
	)
	LG.pop()
end


return Shadow
