local LG = love.graphics
local Snek_3d_Vertex = require "snek_3d.snek_3d_vertex"

local Snek_3d_Sphere = {
	type = "sphere"
}
Snek_3d_Sphere.__index = Snek_3d_Sphere

function Snek_3d_Sphere:create (x, y, z, options)
	local options = options or {}
	local offset = options.offset or {0, 0, 0}
	local point = {
		vertices = {Snek_3d_Vertex:create(x, y, z, offset[1], offset[2], offset[3])},
		size = options.size or 5,
		stroke_color = options.stroke_color or nil,
		fill_color = options.fill_color or nil,
		stroke_width = options.stroke_width or nil,
	}
	setmetatable(point, Snek_3d_Sphere)
	point.vertices[1]:apply_rotation()
	return point
end

function Snek_3d_Sphere:update ()
	self.vertices[1]:apply_rotation()
end

function Snek_3d_Sphere:draw ()
	if self.fill_color then
		LG.setColor(self.fill_color)
		LG.circle("fill", self.vertices[1].screen_x, self.vertices[1].screen_y, self.size / 2)
	end
	if self.stroke_color and self.stroke_width then
		LG.setLineWidth(self.stroke_width)
		LG.setColor(self.stroke_color)
		LG.circle("line", self.vertices[1].screen_x, self.vertices[1].screen_y, self.size / 2)
	end
end

return Snek_3d_Sphere
