local Snek_3d_Vertex = {}
Snek_3d_Vertex.__index = Snek_3d_Vertex

function Snek_3d_Vertex:create (x, y, z, offset_x, offset_y, offset_z)
	local offset_x = offset_x or 0
	local offset_y = offset_y or 0
	local offset_z = offset_z or 0
	local vertex = {
		x = x,
		y = y,
		z = z,
		offset_x = offset_x,
		offset_y = offset_y,
		offset_z = offset_z,
		screen_x = x,
		screen_y = y,
		screen_z = z,
		rotation_x = 0,
		rotation_y = 0,
		rotation_z = 0,
	}
	setmetatable(vertex, Snek_3d_Vertex)
	return vertex
end

function Snek_3d_Vertex:apply_rotation ()
	--http://blog.wolfire.com/2010/07/Linear-algebra-for-game-developers-part-4
	local sin_x = math.sin(self.rotation_x);
	local cos_x = math.cos(self.rotation_x);

	local sin_z = math.sin(self.rotation_z)
	local cos_z = math.cos(self.rotation_z)

	local sin_y = math.sin(self.rotation_y)
	local cos_y = math.cos(self.rotation_y)

	self.screen_x = (self.x * cos_y - self.z * sin_y)
	self.screen_z = (self.z * cos_y + self.x * sin_y)

	local screen_x = self.screen_x
	local orig_y = self.y
	self.screen_x = (screen_x * cos_z - orig_y * sin_z)
	self.screen_y = (orig_y * cos_z + screen_x * sin_z)

	local screen_z = self.screen_z
	local screen_y = self.screen_y
	self.screen_z = (screen_z * cos_x - screen_y * sin_x)
	self.screen_y = (screen_y * cos_x + screen_z * sin_x)

	self.screen_x = self.screen_x + self.offset_x
	self.screen_y = self.screen_y + self.offset_y
	self.screen_z = self.screen_z + self.offset_z
end

return Snek_3d_Vertex
